﻿

public class CLS_Copy
{
	
	
	/// <summary>
	/// This function copyies the child object however many times numberOfCopies is set, applying translation, rotation and scale effects to it.
	/// </summary>
	/// <returns>This function returns nothing.</returns>
	public static function Copy(parent:GameObject, child:Object, numberOfCopies:int, cptranslate:Vector3, cprotate:Vector3, cpscale:Vector3, pivot:Vector3)
	{
		for(var i:int=0;i<numberOfCopies;++i)
		{
			var pos = new Vector3(0f,0f,0f);
			pos.x = cptranslate.x*i + parent.transform.position.x;
			pos.y = cptranslate.y*i + parent.transform.position.y;
			pos.z = cptranslate.z*i + parent.transform.position.z;
			
			
			
			var cpyGO:GameObject = parent.Instantiate(child, pos, Quaternion.identity);
			cpyGO.transform.RotateAround(pivot,Vector3.right,cprotate.x*i);
			cpyGO.transform.RotateAround(pivot,Vector3.up,cprotate.y*i);
			cpyGO.transform.RotateAround(pivot,Vector3.forward,cprotate.z*i);
			
			cpyGO.transform.localScale.x *= Mathf.Pow(cpscale.x,i);
			cpyGO.transform.localScale.y *= Mathf.Pow(cpscale.y,i);
			cpyGO.transform.localScale.z *= Mathf.Pow(cpscale.z,i);
			
			
			cpyGO.name = parent.name + "_" + child.name + "_CPY_" + i.ToString();
			cpyGO.transform.parent = parent.transform;
		
		}
	}
	
	
	/// <summary>
	/// This function copyies the child object however many times numberOfCopies is set, applying translation, rotation and scale effects to it.
	/// This function also has the option to cleanup any children previously spawned.
	/// </summary>
	/// <returns>This function returns nothing.</returns>
	public static function Copy(parent:GameObject, child:Object, numberOfCopies:int, cptranslate:Vector3, cprotate:Vector3, cpscale:Vector3, pivot:Vector3, cleanup:boolean)
	{
		if(cleanup)
		{
			var children:int = parent.transform.childCount;
			for(var i:int =0; i<children;++i)
			{
				parent.Destroy(parent.transform.GetChild((children-i)-1).gameObject);
			}
		}
		Copy(parent,child,numberOfCopies,cptranslate,cprotate,cpscale,pivot);
	}

}

